; Detail.lisp
; displays a snapshot of an interesting CMS screen
; used to handle a request for the image file
; e.g. /Bryan/foo.jpeg

(lambda (exchange)
	(let* (
		(image-path (dictionary-ref (get-exchange-headers exchange) "Path info"))
		(short (lambda (file-name)
			(if (string-ends-with? file-name ".gif")
				(substring file-name 0 (- (string-length file-name) 4))
				(if (string-ends-with? file-name ".jpeg")
					(substring file-name 0 (- (string-length file-name) 5))
					""))))
		(title (file-name (string-URI->string (short image-path))))
		(short-path (+ "Bryan/" title))
		(description
			(if (file-exists? (+ short-path ".text"))
				(file->entity (+ short-path ".text"))
				(if (file-exists? (+ short-path ".txt"))
					(file->entity (+ short-path ".txt"))
					(if (file-exists? (+ short-path ".html"))
						(file->entity (+ short-path ".html"))
						(if (file-exists? (+ short-path ".shtml"))
							(file->evaluated-entity (+ short-path ".shtml"))
							#f))))))
<HTML>

	<SERVER>(eval://firestorm/BryanHead.lisp
		"Bryan Bartle" 
		<HTML><IMG SRC="/image/banner/bdb.gif" ALT="Bryan Donald Bartle" ALIGN=MIDDLE
			HEIGHT=48 WIDTH=306 HSPACE="2" VSPACE="4"></HTML>
		"Sample images for Bryan Bartle.")
	</SERVER>
	
	<TABLE>
		<TR VALIGN=TOP>
			<TD ALIGN=LEFT WIDTH=100>&nbsp;</TD>
			<TD ALIGN=LEFT WIDTH=512>

				<H1><SERVER>title</SERVER></H1>
				
				<IMG BORDER=0 SRC="<SERVER>image-path</SERVER>">
				
				<SERVER>
					(if description
						<HTML>
							<FONT SIZE=4><p><SERVER>description</SERVER></p>
							<HR>
							<FONT SIZE=3><p>This page was rendered dynamically in real time by combining a template, an image file,
							and a small text file containing the description of the image.</p>
						</HTML>
						<HTML>
							<FONT SIZE=3><p>This page was rendered dynamically in real time by combining a template and an image file.
							If a description text file had been by my Dad it would have been included too!.</p>
						</HTML>)
				</SERVER>
				<p>There is a list of available images <A HREF="/firestorm/Bryan">here</A>.
			</TD>
		</TR>
	</TABLE>
	
	<SERVER>eval://firestorm/firefoot.html</SERVER>

</HTML>))
